"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = require("react");
var useRenderCount_1 = tslib_1.__importDefault(require("../useRenderCount"));
function useDebugInformation(componentName, props) {
    var count = (0, useRenderCount_1.default)();
    var changedProps = (0, react_1.useRef)({});
    var previousProps = (0, react_1.useRef)(props);
    var lastRenderTimestamp = (0, react_1.useRef)(Date.now());
    var propKeys = Object.keys(tslib_1.__assign(tslib_1.__assign({}, props), previousProps));
    changedProps.current = propKeys.reduce(function (obj, key) {
        var _a;
        if (props[key] === previousProps.current[key])
            return obj;
        return tslib_1.__assign(tslib_1.__assign({}, obj), (_a = {}, _a[key] = { previous: previousProps.current[key], current: props[key] }, _a));
    }, {});
    var info = {
        count: count,
        changedProps: changedProps.current,
        timeSinceLastRender: Date.now() - lastRenderTimestamp.current,
        lastRenderTimestamp: lastRenderTimestamp.current,
    };
    (0, react_1.useEffect)(function () {
        previousProps.current = props;
        lastRenderTimestamp.current = Date.now();
        console.log("[debug-info]", componentName, info);
    });
    return info;
}
exports.default = useDebugInformation;
