"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
function useStateWithValidation(validationFunc, initialValue) {
    var _a = (0, react_1.useState)(initialValue), state = _a[0], setState = _a[1];
    var _b = (0, react_1.useState)(function () { return validationFunc(state); }), isValid = _b[0], setIsValid = _b[1];
    var onChange = (0, react_1.useCallback)(function (nextState) {
        var value = typeof nextState === "function" ? nextState(state) : nextState;
        setState(value);
        setIsValid(validationFunc(value));
    }, [validationFunc]);
    return [state, onChange, isValid];
}
exports.default = useStateWithValidation;
